# This file was auto-generated by Fern from our API Definition.

from __future__ import annotations
from ..core.unchecked_base_model import UncheckedBaseModel
from .evaluator_response import EvaluatorResponse
from .flow_response import FlowResponse
from .monitoring_evaluator_response import MonitoringEvaluatorResponse
from .prompt_response import PromptResponse
from .tool_response import ToolResponse
from .version_deployment_response import VersionDeploymentResponse
from .version_id_response import VersionIdResponse
from .evaluator_log_response import EvaluatorLogResponse
from .flow_log_response import FlowLogResponse
from .prompt_log_response import PromptLogResponse
from .tool_log_response import ToolLogResponse
from .evaluated_version_response import EvaluatedVersionResponse
import pydantic
from .datapoint_response import DatapointResponse
import typing
from .log_response import LogResponse
from ..core.pydantic_utilities import IS_PYDANTIC_V2
from ..core.pydantic_utilities import update_forward_refs


class EvaluationReportLogResponse(UncheckedBaseModel):
    evaluated_version: EvaluatedVersionResponse = pydantic.Field()
    """
    The version of the Prompt, Tool or Evaluator that the Log belongs to.
    """

    datapoint: DatapointResponse = pydantic.Field()
    """
    The Datapoint used to generate the Log
    """

    log: typing.Optional[LogResponse] = pydantic.Field(default=None)
    """
    The Log that was evaluated by the Evaluator.
    """

    evaluator_logs: typing.List[LogResponse] = pydantic.Field()
    """
    The Evaluator Logs containing the judgments for the Log.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow


update_forward_refs(EvaluatorResponse, EvaluationReportLogResponse=EvaluationReportLogResponse)
update_forward_refs(FlowResponse, EvaluationReportLogResponse=EvaluationReportLogResponse)
update_forward_refs(MonitoringEvaluatorResponse, EvaluationReportLogResponse=EvaluationReportLogResponse)
update_forward_refs(PromptResponse, EvaluationReportLogResponse=EvaluationReportLogResponse)
update_forward_refs(ToolResponse, EvaluationReportLogResponse=EvaluationReportLogResponse)
update_forward_refs(VersionDeploymentResponse, EvaluationReportLogResponse=EvaluationReportLogResponse)
update_forward_refs(VersionIdResponse, EvaluationReportLogResponse=EvaluationReportLogResponse)
update_forward_refs(EvaluatorLogResponse, EvaluationReportLogResponse=EvaluationReportLogResponse)
update_forward_refs(FlowLogResponse, EvaluationReportLogResponse=EvaluationReportLogResponse)
update_forward_refs(PromptLogResponse, EvaluationReportLogResponse=EvaluationReportLogResponse)
update_forward_refs(ToolLogResponse, EvaluationReportLogResponse=EvaluationReportLogResponse)
